"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  computeDiff: () => computeDiff,
  defaultGetDeleteProps: () => defaultGetDeleteProps,
  defaultGetInsertProps: () => defaultGetInsertProps,
  defaultGetUpdateProps: () => defaultGetUpdateProps,
  withGetFragmentExcludeDiff: () => withGetFragmentExcludeDiff
});
module.exports = __toCommonJS(src_exports);

// src/internal/transforms/transformDiffDescendants.ts
var import_server5 = require("@udecode/plate-common/server");
var import_isEqual4 = __toESM(require("lodash/isEqual.js"));

// src/internal/transforms/transformDiffNodes.ts
var import_isEqual = __toESM(require("lodash/isEqual.js"));

// src/internal/utils/copy-without.ts
function copyWithout(obj, w) {
  if (typeof w === "string") {
    w = [w];
  }
  const r = {};
  for (const key in obj) {
    const y = obj[key];
    if (!Array.from(w).includes(key)) {
      r[key] = y;
    }
  }
  return r;
}

// src/internal/transforms/transformDiffNodes.ts
var childrenOnlyStrategy = (node, nextNode, options) => {
  if (node.children != null && nextNode.children != null && (0, import_isEqual.default)(
    copyWithout(node, ["children"]),
    copyWithout(nextNode, ["children"])
  )) {
    const children = computeDiff(
      node.children,
      nextNode.children,
      options
    );
    return [
      __spreadProps(__spreadValues({}, node), {
        children
      })
    ];
  }
  return false;
};
var propsOnlyStrategy = (node, nextNode, { getUpdateProps }) => {
  const properties = {};
  const newProperties = {};
  for (const key in node) {
    if (!(0, import_isEqual.default)(node[key], nextNode[key])) {
      if (key === "children" || key === "text")
        return false;
      properties[key] = node[key];
      newProperties[key] = nextNode[key];
    }
  }
  for (const key in nextNode) {
    if (node[key] === void 0) {
      if (key === "children" || key === "text")
        return false;
      newProperties[key] = nextNode[key];
    }
  }
  return [
    __spreadValues(__spreadValues({}, nextNode), getUpdateProps(node, properties, newProperties))
  ];
};
var strategies = [childrenOnlyStrategy, propsOnlyStrategy];
function transformDiffNodes(node, nextNode, options) {
  for (const strategy of strategies) {
    const ops = strategy(node, nextNode, options);
    if (ops) {
      return ops;
    }
  }
  return false;
}

// src/internal/transforms/transformDiffTexts.ts
var import_server3 = require("@udecode/plate-common/server");
var import_slate2 = require("slate");

// src/internal/diff-match-patch-ts/patch-operation.class.ts
var PatchOperation = class {
  constructor() {
    this.diffs = [];
    this.start1 = null;
    this.start2 = null;
    this.length1 = 0;
    this.length2 = 0;
  }
  /**
   * Emmulate GNU diff's format.
   * Header: @@ -382,8 +481,9 @@
   * Indicies are printed as 1-based, not 0-based.
   */
  toString() {
    let coords1;
    let coords2;
    if (this.length1 === 0) {
      coords1 = this.start1 + ",0";
    } else if (this.length1 === 1) {
      coords1 = this.start1 + 1;
    } else {
      coords1 = this.start1 + 1 + "," + this.length1;
    }
    if (this.length2 === 0) {
      coords2 = this.start2 + ",0";
    } else if (this.length2 === 1) {
      coords2 = this.start2 + 1;
    } else {
      coords2 = this.start2 + 1 + "," + this.length2;
    }
    const text = ["@@ -" + coords1 + " +" + coords2 + " @@\n"];
    let op;
    for (let x = 0; x < this.diffs.length; x++) {
      switch (this.diffs[x][0]) {
        case 1 /* Insert */:
          op = "+";
          break;
        case -1 /* Delete */:
          op = "-";
          break;
        case 0 /* Equal */:
          op = " ";
          break;
      }
      text[x + 1] = op + encodeURI(this.diffs[x][1]) + "\n";
    }
    return text.join("").replace(/%20/g, " ");
  }
};

// src/internal/diff-match-patch-ts/diff-match-patch.class.ts
var DiffMatchPatch = class {
  constructor() {
    // Defaults.
    // Redefine these in your program to override the defaults.
    // Number of seconds to map a diff before giving up (0 for infinity).
    this.Diff_Timeout = 1;
    // Cost of an empty edit operation in terms of edit characters.
    this.Diff_EditCost = 4;
    // At what point is no match declared (0.0 = perfection, 1.0 = very loose).
    this.Match_Threshold = 0.5;
    // How far to search for a match (0 = exact location, 1000+ = broad match).
    // A match this many characters away from the expected location will add
    // 1.0 to the score (0.0 is a perfect match).
    this.Match_Distance = 1e3;
    // When deleting a large block of text (over ~64 characters), how close do
    // the contents have to be to match the expected contents. (0.0 = perfection,
    // 1.0 = very loose).  Note that Match_Threshold controls how closely the
    // end points of a delete need to match.
    this.Patch_DeleteThreshold = 0.5;
    // Chunk size for context length.
    this.Patch_Margin = 4;
    // The number of bits in an int.
    this.Match_MaxBits = 32;
    /**
     * The data structure representing a diff is an array of tuples:
     * [[DiffOp.Delete, 'Hello'], [DiffOp.Insert, 'Goodbye'], [DiffOp.Equal, ' world.']]
     * which means: delete 'Hello', add 'Goodbye' and keep ' world.'
     */
    // Define some regex patterns for matching boundaries.
    this.whitespaceRegex = new RegExp("/s/");
    this.linebreakRegex = new RegExp("/[\r\n]/");
    this.blanklineEndRegex = new RegExp("/\n\r?\n$/");
    this.blanklineStartRegex = new RegExp("/^\r?\n\r?\n/");
  }
  /**
   * Find the differences between two texts.  Simplifies the problem by stripping
   * any common prefix or suffix off the texts before diffing.
   * @param {string} text1 Old string to be diffed.
   * @param {string} text2 New string to be diffed.
   * @param {boolean=} opt_checklines Optional speedup flag. If present and false,
   *     then don't run a line-level diff first to identify the changed areas.
   *     Defaults to true, which does a faster, slightly less optimal diff.
   * @param {number} opt_deadline Optional time when the diff should be complete
   *     by.  Used internally for recursive calls.  Users should set DiffTimeout
   *     instead.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   */
  diff_main(text1, text2, opt_checklines, opt_deadline) {
    if (typeof opt_deadline === "undefined") {
      if (this.Diff_Timeout <= 0) {
        opt_deadline = Number.MAX_VALUE;
      } else {
        opt_deadline = (/* @__PURE__ */ new Date()).getTime() + this.Diff_Timeout * 1e3;
      }
    }
    const deadline = opt_deadline;
    if (text1 == null || text2 == null) {
      throw new Error("Null input. (diff_main)");
    }
    if (text1 === text2) {
      if (text1) {
        return [[0 /* Equal */, text1]];
      }
      return [];
    }
    if (typeof opt_checklines === "undefined") {
      opt_checklines = true;
    }
    const checklines = opt_checklines;
    let commonlength = this.diff_commonPrefix(text1, text2);
    const commonprefix = text1.substring(0, commonlength);
    text1 = text1.substring(commonlength);
    text2 = text2.substring(commonlength);
    commonlength = this.diff_commonSuffix(text1, text2);
    const commonsuffix = text1.substring(text1.length - commonlength);
    text1 = text1.substring(0, text1.length - commonlength);
    text2 = text2.substring(0, text2.length - commonlength);
    const diffs = this.diff_compute_(text1, text2, checklines, deadline);
    if (commonprefix) {
      diffs.unshift([0 /* Equal */, commonprefix]);
    }
    if (commonsuffix) {
      diffs.push([0 /* Equal */, commonsuffix]);
    }
    this.diff_cleanupMerge(diffs);
    return diffs;
  }
  /**
   * Reduce the number of edits by eliminating semantically trivial equalities.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   */
  diff_cleanupSemantic(diffs) {
    let changes = false;
    const equalities = [];
    let equalitiesLength = 0;
    let lastequality = null;
    let pointer = 0;
    let length_insertions1 = 0;
    let length_deletions1 = 0;
    let length_insertions2 = 0;
    let length_deletions2 = 0;
    while (pointer < diffs.length) {
      if (diffs[pointer][0] === 0 /* Equal */) {
        equalities[equalitiesLength++] = pointer;
        length_insertions1 = length_insertions2;
        length_deletions1 = length_deletions2;
        length_insertions2 = 0;
        length_deletions2 = 0;
        lastequality = diffs[pointer][1];
      } else {
        if (diffs[pointer][0] === 1 /* Insert */) {
          length_insertions2 += diffs[pointer][1].length;
        } else {
          length_deletions2 += diffs[pointer][1].length;
        }
        if (lastequality && lastequality.length <= Math.max(length_insertions1, length_deletions1) && lastequality.length <= Math.max(
          length_insertions2,
          length_deletions2
        )) {
          diffs.splice(
            equalities[equalitiesLength - 1],
            0,
            [-1 /* Delete */, lastequality]
          );
          diffs[equalities[equalitiesLength - 1] + 1][0] = 1 /* Insert */;
          equalitiesLength--;
          equalitiesLength--;
          pointer = equalitiesLength > 0 ? equalities[equalitiesLength - 1] : -1;
          length_insertions1 = 0;
          length_deletions1 = 0;
          length_insertions2 = 0;
          length_deletions2 = 0;
          lastequality = null;
          changes = true;
        }
      }
      pointer++;
    }
    if (changes) {
      this.diff_cleanupMerge(diffs);
    }
    this.diff_cleanupSemanticLossless(diffs);
    pointer = 1;
    while (pointer < diffs.length) {
      if (diffs[pointer - 1][0] === -1 /* Delete */ && diffs[pointer][0] === 1 /* Insert */) {
        const deletion = diffs[pointer - 1][1];
        const insertion = diffs[pointer][1];
        const overlap_length1 = this.diff_commonOverlap_(deletion, insertion);
        const overlap_length2 = this.diff_commonOverlap_(insertion, deletion);
        if (overlap_length1 >= overlap_length2) {
          if (overlap_length1 >= deletion.length / 2 || overlap_length1 >= insertion.length / 2) {
            diffs.splice(
              pointer,
              0,
              [0 /* Equal */, insertion.substring(0, overlap_length1)]
            );
            diffs[pointer - 1][1] = deletion.substring(0, deletion.length - overlap_length1);
            diffs[pointer + 1][1] = insertion.substring(overlap_length1);
            pointer++;
          }
        } else {
          if (overlap_length2 >= deletion.length / 2 || overlap_length2 >= insertion.length / 2) {
            diffs.splice(
              pointer,
              0,
              [0 /* Equal */, deletion.substring(0, overlap_length2)]
            );
            diffs[pointer - 1][0] = 1 /* Insert */;
            diffs[pointer - 1][1] = insertion.substring(0, insertion.length - overlap_length2);
            diffs[pointer + 1][0] = -1 /* Delete */;
            diffs[pointer + 1][1] = deletion.substring(overlap_length2);
            pointer++;
          }
        }
        pointer++;
      }
      pointer++;
    }
  }
  /**
   * Reduce the number of edits by eliminating operationally trivial equalities.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   */
  diff_cleanupEfficiency(diffs) {
    let changes = false;
    const equalities = [];
    let equalitiesLength = 0;
    let lastequality = null;
    let pointer = 0;
    let pre_ins = false;
    let pre_del = false;
    let post_ins = false;
    let post_del = false;
    while (pointer < diffs.length) {
      if (diffs[pointer][0] === 0 /* Equal */) {
        if (diffs[pointer][1].length < this.Diff_EditCost && (post_ins || post_del)) {
          equalities[equalitiesLength++] = pointer;
          pre_ins = post_ins;
          pre_del = post_del;
          lastequality = diffs[pointer][1];
        } else {
          equalitiesLength = 0;
          lastequality = null;
        }
        post_ins = post_del = false;
      } else {
        if (diffs[pointer][0] === -1 /* Delete */) {
          post_del = true;
        } else {
          post_ins = true;
        }
        if (lastequality && (pre_ins && pre_del && post_ins && post_del || lastequality.length < this.Diff_EditCost / 2 && (pre_ins ? 1 : 0) + (pre_del ? 1 : 0) + (post_ins ? 1 : 0) + (post_del ? 1 : 0) === 3)) {
          diffs.splice(
            equalities[equalitiesLength - 1],
            0,
            [-1 /* Delete */, lastequality]
          );
          diffs[equalities[equalitiesLength - 1] + 1][0] = 1 /* Insert */;
          equalitiesLength--;
          lastequality = null;
          if (pre_ins && pre_del) {
            post_ins = post_del = true;
            equalitiesLength = 0;
          } else {
            equalitiesLength--;
            pointer = equalitiesLength > 0 ? equalities[equalitiesLength - 1] : -1;
            post_ins = post_del = false;
          }
          changes = true;
        }
      }
      pointer++;
    }
    if (changes) {
      this.diff_cleanupMerge(diffs);
    }
  }
  /**
   * Convert a diff array into a pretty HTML report.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @return {string} HTML representation.
   */
  diff_prettyHtml(diffs) {
    const html = [];
    const pattern_amp = /&/g;
    const pattern_lt = /</g;
    const pattern_gt = />/g;
    const pattern_para = /\n/g;
    for (let x = 0; x < diffs.length; x++) {
      const op = diffs[x][0];
      const data = diffs[x][1];
      const text = data.replace(pattern_amp, "&amp;").replace(pattern_lt, "&lt;").replace(pattern_gt, "&gt;").replace(pattern_para, "&para;<br>");
      switch (op) {
        case 1 /* Insert */:
          html[x] = '<ins style="background:#e6ffe6;">' + text + "</ins>";
          break;
        case -1 /* Delete */:
          html[x] = '<del style="background:#ffe6e6;">' + text + "</del>";
          break;
        case 0 /* Equal */:
          html[x] = "<span>" + text + "</span>";
          break;
      }
    }
    return html.join("");
  }
  /**
   * Compute the Levenshtein distance; the number of inserted, deleted or
   * substituted characters.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @return {number} Number of changes.
   */
  diff_levenshtein(diffs) {
    let levenshtein = 0;
    let insertions = 0;
    let deletions = 0;
    for (const diff of diffs) {
      const op = diff[0];
      const data = diff[1];
      switch (op) {
        case 1 /* Insert */:
          insertions += data.length;
          break;
        case -1 /* Delete */:
          deletions += data.length;
          break;
        case 0 /* Equal */:
          levenshtein += Math.max(insertions, deletions);
          insertions = 0;
          deletions = 0;
          break;
      }
    }
    levenshtein += Math.max(insertions, deletions);
    return levenshtein;
  }
  /**
   * Compute a list of patches to turn text1 into text2.
   * Use diffs if provided, otherwise compute it ourselves.
   * There are four ways to call this function, depending on what data is
   * available to the caller:
   * Method 1:
   * a = text1, b = text2
   * Method 2:
   * a = diffs
   * Method 3 (optimal):
   * a = text1, b = diffs
   * Method 4 (deprecated, use method 3):
   * a = text1, b = text2, c = diffs
   *
   * @param {string|!Array.<!diff_match_patch.Diff>} a text1 (methods 1,3,4) or
   * Array of diff tuples for text1 to text2 (method 2).
   * @param {string|!Array.<!diff_match_patch.Diff>} opt_b text2 (methods 1,4) or
   * Array of diff tuples for text1 to text2 (method 3) or undefined (method 2).
   * @param {string|!Array.<!diff_match_patch.Diff>} opt_c Array of diff tuples
   * for text1 to text2 (method 4) or undefined (methods 1,2,3).
   * @return {!Array.<!diff_match_patch.PatchOperation>} Array of Patch objects.
   */
  patch_make(a, opt_b, opt_c) {
    let text1;
    let diffs;
    if (typeof a === "string" && typeof opt_b === "string" && typeof opt_c === "undefined") {
      text1 = /** @type {string} */
      a;
      diffs = this.diff_main(
        text1,
        /** @type {string} */
        opt_b,
        true
      );
      if (diffs.length > 2) {
        this.diff_cleanupSemantic(diffs);
        this.diff_cleanupEfficiency(diffs);
      }
    } else if (a && typeof a === "object" && typeof opt_b === "undefined" && typeof opt_c === "undefined") {
      diffs = /** @type {!Array.<!diff_match_patch.Diff>} */
      a;
      text1 = this.diff_text1(diffs);
    } else if (typeof a === "string" && opt_b && typeof opt_b === "object" && typeof opt_c === "undefined") {
      text1 = /** @type {string} */
      a;
      diffs = /** @type {!Array.<!diff_match_patch.Diff>} */
      opt_b;
    } else if (typeof a === "string" && typeof opt_b === "string" && opt_c && typeof opt_c === "object") {
      text1 = /** @type {string} */
      a;
      diffs = /** @type {!Array.<!diff_match_patch.Diff>} */
      opt_c;
    } else {
      throw new Error("Unknown call format to patch_make.");
    }
    if (diffs.length === 0) {
      return [];
    }
    const patches = [];
    let patch = new PatchOperation();
    let patchDiffLength = 0;
    let char_count1 = 0;
    let char_count2 = 0;
    let prepatch_text = text1;
    let postpatch_text = text1;
    for (let x = 0; x < diffs.length; x++) {
      const diff_type = diffs[x][0];
      const diff_text = diffs[x][1];
      if (!patchDiffLength && diff_type !== 0 /* Equal */) {
        patch.start1 = char_count1;
        patch.start2 = char_count2;
      }
      switch (diff_type) {
        case 1 /* Insert */:
          patch.diffs[patchDiffLength++] = diffs[x];
          patch.length2 += diff_text.length;
          postpatch_text = postpatch_text.substring(0, char_count2) + diff_text + postpatch_text.substring(char_count2);
          break;
        case -1 /* Delete */:
          patch.length1 += diff_text.length;
          patch.diffs[patchDiffLength++] = diffs[x];
          postpatch_text = postpatch_text.substring(0, char_count2) + postpatch_text.substring(char_count2 + diff_text.length);
          break;
        case 0 /* Equal */:
          if (diff_text.length <= 2 * this.Patch_Margin && patchDiffLength && diffs.length !== x + 1) {
            patch.diffs[patchDiffLength++] = diffs[x];
            patch.length1 += diff_text.length;
            patch.length2 += diff_text.length;
          } else if (diff_text.length >= 2 * this.Patch_Margin) {
            if (patchDiffLength) {
              this.patch_addContext_(patch, prepatch_text);
              patches.push(patch);
              patch = new PatchOperation();
              patchDiffLength = 0;
              prepatch_text = postpatch_text;
              char_count1 = char_count2;
            }
          }
          break;
      }
      if (diff_type !== 1 /* Insert */) {
        char_count1 += diff_text.length;
      }
      if (diff_type !== -1 /* Delete */) {
        char_count2 += diff_text.length;
      }
    }
    if (patchDiffLength) {
      this.patch_addContext_(patch, prepatch_text);
      patches.push(patch);
    }
    return patches;
  }
  /**
   * Merge a set of patches onto the text.  Return a patched text, as well
   * as a list of true/false values indicating which patches were applied.
   * @param {!Array.<!diff_match_patch.PatchOperation>} patches Array of Patch objects.
   * @param {string} text Old text.
   * @return {!Array.<string|!Array.<boolean>>} Two element Array, containing the
   *      new text and an array of boolean values.
   */
  patch_apply(patches, text) {
    if (patches.length === 0) {
      return [text, []];
    }
    patches = this.patch_deepCopy(patches);
    const nullPadding = this.patch_addPadding(patches);
    text = nullPadding + text + nullPadding;
    this.patch_splitMax(patches);
    let delta = 0;
    const results = [];
    for (let x = 0; x < patches.length; x++) {
      const expected_loc = patches[x].start2 + delta;
      const text1 = this.diff_text1(patches[x].diffs);
      let start_loc;
      let end_loc = -1;
      if (text1.length > this.Match_MaxBits) {
        start_loc = this.match_main(
          text,
          text1.substring(0, this.Match_MaxBits),
          expected_loc
        );
        if (start_loc !== -1) {
          end_loc = this.match_main(
            text,
            text1.substring(text1.length - this.Match_MaxBits),
            expected_loc + text1.length - this.Match_MaxBits
          );
          if (end_loc === -1 || start_loc >= end_loc) {
            start_loc = -1;
          }
        }
      } else {
        start_loc = this.match_main(text, text1, expected_loc);
      }
      if (start_loc === -1) {
        results[x] = false;
        delta -= patches[x].length2 - patches[x].length1;
      } else {
        results[x] = true;
        delta = start_loc - expected_loc;
        let text2;
        if (end_loc === -1) {
          text2 = text.substring(start_loc, start_loc + text1.length);
        } else {
          text2 = text.substring(start_loc, end_loc + this.Match_MaxBits);
        }
        if (text1 === text2) {
          text = text.substring(0, start_loc) + this.diff_text2(patches[x].diffs) + text.substring(start_loc + text1.length);
        } else {
          const diffs = this.diff_main(text1, text2, false);
          if (text1.length > this.Match_MaxBits && this.diff_levenshtein(diffs) / text1.length > this.Patch_DeleteThreshold) {
            results[x] = false;
          } else {
            this.diff_cleanupSemanticLossless(diffs);
            let index1 = 0;
            let index2;
            for (const diff of patches[x].diffs) {
              if (diff[0] !== 0 /* Equal */) {
                index2 = this.diff_xIndex(diffs, index1);
              }
              if (diff[0] === 1 /* Insert */) {
                text = text.substring(0, start_loc + index2) + diff[1] + text.substring(start_loc + index2);
              } else if (diff[0] === -1 /* Delete */) {
                text = text.substring(0, start_loc + index2) + text.substring(start_loc + this.diff_xIndex(
                  diffs,
                  index1 + diff[1].length
                ));
              }
              if (diff[0] !== -1 /* Delete */) {
                index1 += diff[1].length;
              }
            }
          }
        }
      }
    }
    text = text.substring(nullPadding.length, text.length - nullPadding.length);
    return [text, results];
  }
  /**
   * Take a list of patches and return a textual representation.
   * @param {!Array.<!diff_match_patch.PatchOperation>} patches Array of Patch objects.
   * @return {string} Text representation of patches.
   */
  patch_toText(patches) {
    const text = [];
    for (let x = 0; x < patches.length; x++) {
      text[x] = patches[x];
    }
    return text.join("");
  }
  /**
   * Parse a textual representation of patches and return a list of Patch objects.
   * @param {string} textline Text representation of patches.
   * @return {!Array.<!diff_match_patch.PatchOperation>} Array of Patch objects.
   * @throws {!Error} If invalid input.
   */
  patch_fromText(textline) {
    const patches = [];
    if (!textline) {
      return patches;
    }
    const text = textline.split("\n");
    let textPointer = 0;
    const patchHeader = /^@@ -(\d+),?(\d*) \+(\d+),?(\d*) @@$/;
    while (textPointer < text.length) {
      const m = text[textPointer].match(patchHeader);
      if (!m) {
        throw new Error("Invalid patch string: " + text[textPointer]);
      }
      const patch = new PatchOperation();
      patches.push(patch);
      patch.start1 = parseInt(m[1], 10);
      if (m[2] === "") {
        patch.start1--;
        patch.length1 = 1;
      } else if (m[2] === "0") {
        patch.length1 = 0;
      } else {
        patch.start1--;
        patch.length1 = parseInt(m[2], 10);
      }
      patch.start2 = parseInt(m[3], 10);
      if (m[4] === "") {
        patch.start2--;
        patch.length2 = 1;
      } else if (m[4] === "0") {
        patch.length2 = 0;
      } else {
        patch.start2--;
        patch.length2 = parseInt(m[4], 10);
      }
      textPointer++;
      while (textPointer < text.length) {
        const sign = text[textPointer].charAt(0);
        let line;
        try {
          line = decodeURI(text[textPointer].substring(1));
        } catch (ex) {
          throw new Error("Illegal escape in patch_fromText: " + line);
        }
        if (sign === "-") {
          patch.diffs.push([-1 /* Delete */, line]);
        } else if (sign === "+") {
          patch.diffs.push([1 /* Insert */, line]);
        } else if (sign === " ") {
          patch.diffs.push([0 /* Equal */, line]);
        } else if (sign === "@") {
          break;
        } else if (sign === "") {
        } else {
          throw new Error('Invalid patch mode "' + sign + '" in: ' + line);
        }
        textPointer++;
      }
    }
    return patches;
  }
  /**
   * Determine the common prefix of two strings.
   * @param {string} text1 First string.
   * @param {string} text2 Second string.
   * @return {number} The number of characters common to the start of each
   *     string.
   */
  diff_commonPrefix(text1, text2) {
    if (!text1 || !text2 || text1.charAt(0) !== text2.charAt(0)) {
      return 0;
    }
    let pointermin = 0;
    let pointermax = Math.min(text1.length, text2.length);
    let pointermid = pointermax;
    let pointerstart = 0;
    while (pointermin < pointermid) {
      if (text1.substring(pointerstart, pointermid) === text2.substring(pointerstart, pointermid)) {
        pointermin = pointermid;
        pointerstart = pointermin;
      } else {
        pointermax = pointermid;
      }
      pointermid = Math.floor((pointermax - pointermin) / 2 + pointermin);
    }
    return pointermid;
  }
  /**
   * Determine the common suffix of two strings.
   * @param {string} text1 First string.
   * @param {string} text2 Second string.
   * @return {number} The number of characters common to the end of each string.
   */
  diff_commonSuffix(text1, text2) {
    if (!text1 || !text2 || text1.charAt(text1.length - 1) !== text2.charAt(text2.length - 1)) {
      return 0;
    }
    let pointermin = 0;
    let pointermax = Math.min(text1.length, text2.length);
    let pointermid = pointermax;
    let pointerend = 0;
    while (pointermin < pointermid) {
      if (text1.substring(text1.length - pointermid, text1.length - pointerend) === text2.substring(text2.length - pointermid, text2.length - pointerend)) {
        pointermin = pointermid;
        pointerend = pointermin;
      } else {
        pointermax = pointermid;
      }
      pointermid = Math.floor((pointermax - pointermin) / 2 + pointermin);
    }
    return pointermid;
  }
  /**
   * Reorder and merge like edit sections.  Merge equalities.
   * Any edit section can move as long as it doesn't cross an equality.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   */
  diff_cleanupMerge(diffs) {
    diffs.push([0 /* Equal */, ""]);
    let pointer = 0;
    let count_delete = 0;
    let count_insert = 0;
    let text_delete = "";
    let text_insert = "";
    let commonlength;
    while (pointer < diffs.length) {
      switch (diffs[pointer][0]) {
        case 1 /* Insert */:
          count_insert++;
          text_insert += diffs[pointer][1];
          pointer++;
          break;
        case -1 /* Delete */:
          count_delete++;
          text_delete += diffs[pointer][1];
          pointer++;
          break;
        case 0 /* Equal */:
          if (count_delete + count_insert > 1) {
            if (count_delete !== 0 && count_insert !== 0) {
              commonlength = this.diff_commonPrefix(text_insert, text_delete);
              if (commonlength !== 0) {
                if (pointer - count_delete - count_insert > 0 && diffs[pointer - count_delete - count_insert - 1][0] === 0 /* Equal */) {
                  diffs[pointer - count_delete - count_insert - 1][1] += text_insert.substring(0, commonlength);
                } else {
                  diffs.splice(0, 0, [
                    0 /* Equal */,
                    text_insert.substring(0, commonlength)
                  ]);
                  pointer++;
                }
                text_insert = text_insert.substring(commonlength);
                text_delete = text_delete.substring(commonlength);
              }
              commonlength = this.diff_commonSuffix(text_insert, text_delete);
              if (commonlength !== 0) {
                diffs[pointer][1] = text_insert.substring(text_insert.length - commonlength) + diffs[pointer][1];
                text_insert = text_insert.substring(0, text_insert.length - commonlength);
                text_delete = text_delete.substring(0, text_delete.length - commonlength);
              }
            }
            if (count_delete === 0) {
              diffs.splice(
                pointer - count_insert,
                count_delete + count_insert,
                [1 /* Insert */, text_insert]
              );
            } else if (count_insert === 0) {
              diffs.splice(
                pointer - count_delete,
                count_delete + count_insert,
                [-1 /* Delete */, text_delete]
              );
            } else {
              diffs.splice(
                pointer - count_delete - count_insert,
                count_delete + count_insert,
                [-1 /* Delete */, text_delete],
                [1 /* Insert */, text_insert]
              );
            }
            pointer = pointer - count_delete - count_insert + (count_delete ? 1 : 0) + (count_insert ? 1 : 0) + 1;
          } else if (pointer !== 0 && diffs[pointer - 1][0] === 0 /* Equal */) {
            diffs[pointer - 1][1] += diffs[pointer][1];
            diffs.splice(pointer, 1);
          } else {
            pointer++;
          }
          count_insert = 0;
          count_delete = 0;
          text_delete = "";
          text_insert = "";
          break;
      }
    }
    if (diffs[diffs.length - 1][1] === "") {
      diffs.pop();
    }
    let changes = false;
    pointer = 1;
    while (pointer < diffs.length - 1) {
      if (diffs[pointer - 1][0] === 0 /* Equal */ && diffs[pointer + 1][0] === 0 /* Equal */) {
        if (diffs[pointer][1].substring(diffs[pointer][1].length - diffs[pointer - 1][1].length) === diffs[pointer - 1][1]) {
          diffs[pointer][1] = diffs[pointer - 1][1] + diffs[pointer][1].substring(0, diffs[pointer][1].length - diffs[pointer - 1][1].length);
          diffs[pointer + 1][1] = diffs[pointer - 1][1] + diffs[pointer + 1][1];
          diffs.splice(pointer - 1, 1);
          changes = true;
        } else if (diffs[pointer][1].substring(0, diffs[pointer + 1][1].length) === diffs[pointer + 1][1]) {
          diffs[pointer - 1][1] += diffs[pointer + 1][1];
          diffs[pointer][1] = diffs[pointer][1].substring(diffs[pointer + 1][1].length) + diffs[pointer + 1][1];
          diffs.splice(pointer + 1, 1);
          changes = true;
        }
      }
      pointer++;
    }
    if (changes) {
      this.diff_cleanupMerge(diffs);
    }
  }
  /**
   * Compute and return the source text (all equalities and deletions).
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @return {string} Source text.
   */
  diff_text1(diffs) {
    const text = [];
    for (let x = 0; x < diffs.length; x++) {
      if (diffs[x][0] !== 1 /* Insert */) {
        text[x] = diffs[x][1];
      }
    }
    return text.join("");
  }
  /**
   * Compute and return the destination text (all equalities and insertions).
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @return {string} Destination text.
   */
  diff_text2(diffs) {
    const text = [];
    for (let x = 0; x < diffs.length; x++) {
      if (diffs[x][0] !== -1 /* Delete */) {
        text[x] = diffs[x][1];
      }
    }
    return text.join("");
  }
  /**
   * Compute and return a line-mode diff.
   * @param {string} text1 Old string to be diffed.
   * @param {string} text2 New string to be diffed.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   */
  diff_lineMode(text1, text2) {
    const encodedStrings = this.diff_linesToChars_(text1, text2);
    const diffs = this.diff_main(encodedStrings.chars1, encodedStrings.chars2, false);
    this.diff_charsToLines_(diffs, encodedStrings.lineArray);
    return diffs;
  }
  /**
   * Find the differences between two texts.  Assumes that the texts do not
   * have any common prefix or suffix.
   * @param {string} text1 Old string to be diffed.
   * @param {string} text2 New string to be diffed.
   * @param {boolean} checklines Speedup flag.  If false, then don't run a
   *     line-level diff first to identify the changed areas.
   *     If true, then run a faster, slightly less optimal diff.
   * @param {number} deadline Time when the diff should be complete by.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   * @private
   */
  diff_compute_(text1, text2, checklines, deadline) {
    let diffs;
    if (!text1) {
      return [[1 /* Insert */, text2]];
    }
    if (!text2) {
      return [[-1 /* Delete */, text1]];
    }
    const longtext = text1.length > text2.length ? text1 : text2;
    const shorttext = text1.length > text2.length ? text2 : text1;
    const i = longtext.indexOf(shorttext);
    if (i !== -1) {
      diffs = [
        [1 /* Insert */, longtext.substring(0, i)],
        [0 /* Equal */, shorttext],
        [1 /* Insert */, longtext.substring(i + shorttext.length)]
      ];
      if (text1.length > text2.length) {
        diffs[0][0] = diffs[2][0] = -1 /* Delete */;
      }
      return diffs;
    }
    if (shorttext.length === 1) {
      return [[-1 /* Delete */, text1], [1 /* Insert */, text2]];
    }
    const hm = this.diff_halfMatch_(text1, text2);
    if (hm) {
      const text1_a = hm[0];
      const text1_b = hm[1];
      const text2_a = hm[2];
      const text2_b = hm[3];
      const mid_common = hm[4];
      const diffs_a = this.diff_main(text1_a, text2_a, checklines, deadline);
      const diffs_b = this.diff_main(text1_b, text2_b, checklines, deadline);
      return diffs_a.concat([[0 /* Equal */, mid_common]], diffs_b);
    }
    if (checklines && text1.length > 100 && text2.length > 100) {
      return this.diff_lineMode_(text1, text2, deadline);
    }
    return this.diff_bisect_(text1, text2, deadline);
  }
  /**
   * Do a quick line-level diff on both strings, then rediff the parts for
   * greater accuracy.
   * This speedup can produce non-minimal diffs.
   * @param {string} text1 Old string to be diffed.
   * @param {string} text2 New string to be diffed.
   * @param {number} deadline Time when the diff should be complete by.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   * @private
   */
  diff_lineMode_(text1, text2, deadline) {
    const a = this.diff_linesToChars_(text1, text2);
    text1 = a.chars1;
    text2 = a.chars2;
    const linearray = a.lineArray;
    const diffs = this.diff_main(text1, text2, false, deadline);
    this.diff_charsToLines_(diffs, linearray);
    this.diff_cleanupSemantic(diffs);
    diffs.push([0 /* Equal */, ""]);
    let pointer = 0;
    let count_delete = 0;
    let count_insert = 0;
    let text_delete = "";
    let text_insert = "";
    while (pointer < diffs.length) {
      switch (diffs[pointer][0]) {
        case 1 /* Insert */:
          count_insert++;
          text_insert += diffs[pointer][1];
          break;
        case -1 /* Delete */:
          count_delete++;
          text_delete += diffs[pointer][1];
          break;
        case 0 /* Equal */:
          if (count_delete >= 1 && count_insert >= 1) {
            diffs.splice(
              pointer - count_delete - count_insert,
              count_delete + count_insert
            );
            pointer = pointer - count_delete - count_insert;
            const b = this.diff_main(text_delete, text_insert, false, deadline);
            for (let j = b.length - 1; j >= 0; j--) {
              diffs.splice(pointer, 0, b[j]);
            }
            pointer = pointer + b.length;
          }
          count_insert = 0;
          count_delete = 0;
          text_delete = "";
          text_insert = "";
          break;
      }
      pointer++;
    }
    diffs.pop();
    return diffs;
  }
  /**
   * Find the 'middle snake' of a diff, split the problem in two
   * and return the recursively constructed diff.
   * See Myers 1986 paper: An O(ND) Difference Algorithm and Its constiations.
   * @param {string} text1 Old string to be diffed.
   * @param {string} text2 New string to be diffed.
   * @param {number} deadline Time at which to bail if not yet complete.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   * @private
   */
  diff_bisect_(text1, text2, deadline) {
    const text1_length = text1.length;
    const text2_length = text2.length;
    const max_d = Math.ceil((text1_length + text2_length) / 2);
    const v_offset = max_d;
    const v_length = 2 * max_d;
    const v1 = new Array(v_length);
    const v2 = new Array(v_length);
    for (let x = 0; x < v_length; x++) {
      v1[x] = -1;
      v2[x] = -1;
    }
    v1[v_offset + 1] = 0;
    v2[v_offset + 1] = 0;
    const delta = text1_length - text2_length;
    const front = delta % 2 !== 0;
    let k1start = 0;
    let k1end = 0;
    let k2start = 0;
    let k2end = 0;
    for (let d = 0; d < max_d; d++) {
      if ((/* @__PURE__ */ new Date()).getTime() > deadline) {
        break;
      }
      for (let k1 = -d + k1start; k1 <= d - k1end; k1 += 2) {
        const k1_offset = v_offset + k1;
        let x1;
        if (k1 === -d || k1 !== d && v1[k1_offset - 1] < v1[k1_offset + 1]) {
          x1 = v1[k1_offset + 1];
        } else {
          x1 = v1[k1_offset - 1] + 1;
        }
        let y1 = x1 - k1;
        while (x1 < text1_length && y1 < text2_length && text1.charAt(x1) === text2.charAt(y1)) {
          x1++;
          y1++;
        }
        v1[k1_offset] = x1;
        if (x1 > text1_length) {
          k1end += 2;
        } else if (y1 > text2_length) {
          k1start += 2;
        } else if (front) {
          const k2_offset = v_offset + delta - k1;
          if (k2_offset >= 0 && k2_offset < v_length && v2[k2_offset] !== -1) {
            const x2 = text1_length - v2[k2_offset];
            if (x1 >= x2) {
              return this.diff_bisectSplit_(text1, text2, x1, y1, deadline);
            }
          }
        }
      }
      for (let k2 = -d + k2start; k2 <= d - k2end; k2 += 2) {
        const k2_offset = v_offset + k2;
        let x2;
        if (k2 === -d || k2 !== d && v2[k2_offset - 1] < v2[k2_offset + 1]) {
          x2 = v2[k2_offset + 1];
        } else {
          x2 = v2[k2_offset - 1] + 1;
        }
        let y2 = x2 - k2;
        while (x2 < text1_length && y2 < text2_length && text1.charAt(text1_length - x2 - 1) === text2.charAt(text2_length - y2 - 1)) {
          x2++;
          y2++;
        }
        v2[k2_offset] = x2;
        if (x2 > text1_length) {
          k2end += 2;
        } else if (y2 > text2_length) {
          k2start += 2;
        } else if (!front) {
          const k1_offset = v_offset + delta - k2;
          if (k1_offset >= 0 && k1_offset < v_length && v1[k1_offset] !== -1) {
            const x1 = v1[k1_offset];
            const y1 = v_offset + x1 - k1_offset;
            x2 = text1_length - x2;
            if (x1 >= x2) {
              return this.diff_bisectSplit_(text1, text2, x1, y1, deadline);
            }
          }
        }
      }
    }
    return [[-1 /* Delete */, text1], [1 /* Insert */, text2]];
  }
  /**
   * Given the location of the 'middle snake', split the diff in two parts
   * and recurse.
   * @param {string} text1 Old string to be diffed.
   * @param {string} text2 New string to be diffed.
   * @param {number} x Index of split point in text1.
   * @param {number} y Index of split point in text2.
   * @param {number} deadline Time at which to bail if not yet complete.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   * @private
   */
  diff_bisectSplit_(text1, text2, x, y, deadline) {
    const text1a = text1.substring(0, x);
    const text2a = text2.substring(0, y);
    const text1b = text1.substring(x);
    const text2b = text2.substring(y);
    const diffs = this.diff_main(text1a, text2a, false, deadline);
    const diffsb = this.diff_main(text1b, text2b, false, deadline);
    return diffs.concat(diffsb);
  }
  /**
   * Split two texts into an array of strings.  Reduce the texts to a string of
   * hashes where each Unicode character represents one line.
   * @param {string} text1 First string.
   * @param {string} text2 Second string.
   * @return {{chars1: string, chars2: string, lineArray: !Array.<string>}}
   *     An object containing the encoded text1, the encoded text2 and
   *     the array of unique strings.
   *     The zeroth element of the array of unique strings is intentionally blank.
   * @private
   */
  diff_linesToChars_(text1, text2) {
    const lineArray = [];
    const lineHash = {};
    lineArray[0] = "";
    const chars1 = this.diff_linesToCharsMunge_(text1, lineArray, lineHash);
    const chars2 = this.diff_linesToCharsMunge_(text2, lineArray, lineHash);
    return { chars1, chars2, lineArray };
  }
  /**
   * Split a text into an array of strings.  Reduce the texts to a string of
   * hashes where each Unicode character represents one line.
   * Modifies linearray and linehash through being a closure.
   * @param {string} text String to encode.
   * @return {string} Encoded string.
   * @private
   */
  diff_linesToCharsMunge_(text, lineArray, lineHash) {
    let chars = "";
    let lineStart = 0;
    let lineEnd = -1;
    let lineArrayLength = lineArray.length;
    while (lineEnd < text.length - 1) {
      lineEnd = text.indexOf("\n", lineStart);
      if (lineEnd === -1) {
        lineEnd = text.length - 1;
      }
      const line = text.substring(lineStart, lineEnd + 1);
      lineStart = lineEnd + 1;
      if (lineHash.hasOwnProperty ? lineHash.hasOwnProperty(line) : lineHash[line] !== void 0) {
        chars += String.fromCharCode(lineHash[line]);
      } else {
        chars += String.fromCharCode(lineArrayLength);
        lineHash[line] = lineArrayLength;
        lineArray[lineArrayLength++] = line;
      }
    }
    return chars;
  }
  /**
   * Rehydrate the text in a diff from a string of line hashes to real lines of
   * text.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @param {!Array.<string>} lineArray Array of unique strings.
   * @private
   */
  diff_charsToLines_(diffs, lineArray) {
    for (const diff of diffs) {
      const chars = diff[1];
      const text = [];
      for (let y = 0; y < chars.length; y++) {
        text[y] = lineArray[chars.charCodeAt(y)];
      }
      diff[1] = text.join("");
    }
  }
  /**
   * Determine if the suffix of one string is the prefix of another.
   * @param {string} text1 First string.
   * @param {string} text2 Second string.
   * @return {number} The number of characters common to the end of the first
   *     string and the start of the second string.
   * @private
   */
  diff_commonOverlap_(text1, text2) {
    const text1_length = text1.length;
    const text2_length = text2.length;
    if (text1_length === 0 || text2_length === 0) {
      return 0;
    }
    if (text1_length > text2_length) {
      text1 = text1.substring(text1_length - text2_length);
    } else if (text1_length < text2_length) {
      text2 = text2.substring(0, text1_length);
    }
    const text_length = Math.min(text1_length, text2_length);
    if (text1 === text2) {
      return text_length;
    }
    let best = 0;
    let length = 1;
    while (true) {
      const pattern = text1.substring(text_length - length);
      const found = text2.indexOf(pattern);
      if (found === -1) {
        return best;
      }
      length += found;
      if (found === 0 || text1.substring(text_length - length) === text2.substring(0, length)) {
        best = length;
        length++;
      }
    }
  }
  /**
   * Do the two texts share a substring which is at least half the length of the
   * longer text?
   * This speedup can produce non-minimal diffs.
   * @param {string} text1 First string.
   * @param {string} text2 Second string.
   * @return {Array.<string>} Five element Array, containing the prefix of
   *     text1, the suffix of text1, the prefix of text2, the suffix of
   *     text2 and the common middle.  Or null if there was no match.
   * @private
   */
  diff_halfMatch_(text1, text2) {
    if (this.Diff_Timeout <= 0) {
      return null;
    }
    const longtext = text1.length > text2.length ? text1 : text2;
    const shorttext = text1.length > text2.length ? text2 : text1;
    if (longtext.length < 4 || shorttext.length * 2 < longtext.length) {
      return null;
    }
    const dmp2 = this;
    const hm1 = this.diff_halfMatchI_(
      longtext,
      shorttext,
      Math.ceil(longtext.length / 4),
      dmp2
    );
    const hm2 = this.diff_halfMatchI_(
      longtext,
      shorttext,
      Math.ceil(longtext.length / 2),
      dmp2
    );
    let hm;
    if (!hm1 && !hm2) {
      return null;
    } else if (!hm2) {
      hm = hm1;
    } else if (!hm1) {
      hm = hm2;
    } else {
      hm = hm1[4].length > hm2[4].length ? hm1 : hm2;
    }
    let text1_a;
    let text1_b;
    let text2_a;
    let text2_b;
    if (text1.length > text2.length) {
      text1_a = hm[0];
      text1_b = hm[1];
      text2_a = hm[2];
      text2_b = hm[3];
    } else {
      text2_a = hm[0];
      text2_b = hm[1];
      text1_a = hm[2];
      text1_b = hm[3];
    }
    const mid_common = hm[4];
    return [text1_a, text1_b, text2_a, text2_b, mid_common];
  }
  /**
   * Does a substring of shorttext exist within longtext such that the substring
   * is at least half the length of longtext?
   * Closure, but does not reference any external constiables.
   * @param {string} longtext Longer string.
   * @param {string} shorttext Shorter string.
   * @param {number} i Start index of quarter length substring within longtext.
   * @return {Array.<string>} Five element Array, containing the prefix of
   *     longtext, the suffix of longtext, the prefix of shorttext, the suffix
   *     of shorttext and the common middle.  Or null if there was no match.
   * @private
   */
  diff_halfMatchI_(longtext, shorttext, i, dmp2) {
    const seed = longtext.substring(i, i + Math.floor(longtext.length / 4));
    let j = -1;
    let best_common = "";
    let best_longtext_a;
    let best_longtext_b;
    let best_shorttext_a;
    let best_shorttext_b;
    while ((j = shorttext.indexOf(seed, j + 1)) !== -1) {
      const prefixLength = dmp2.diff_commonPrefix(
        longtext.substring(i),
        shorttext.substring(j)
      );
      const suffixLength = dmp2.diff_commonSuffix(
        longtext.substring(0, i),
        shorttext.substring(0, j)
      );
      if (best_common.length < suffixLength + prefixLength) {
        best_common = shorttext.substring(j - suffixLength, j) + shorttext.substring(j, j + prefixLength);
        best_longtext_a = longtext.substring(0, i - suffixLength);
        best_longtext_b = longtext.substring(i + prefixLength);
        best_shorttext_a = shorttext.substring(0, j - suffixLength);
        best_shorttext_b = shorttext.substring(j + prefixLength);
      }
    }
    if (best_common.length * 2 >= longtext.length) {
      return [
        best_longtext_a,
        best_longtext_b,
        best_shorttext_a,
        best_shorttext_b,
        best_common
      ];
    } else {
      return null;
    }
  }
  /**
   * Look for single edits surrounded on both sides by equalities
   * which can be shifted sideways to align the edit to a word boundary.
   * e.g: The c<ins>at c</ins>ame. -> The <ins>cat </ins>came.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   */
  diff_cleanupSemanticLossless(diffs) {
    const diff_cleanupSemanticScore_ = (one, two) => {
      if (!one || !two) {
        return 6;
      }
      const nonAlphaNumericRegex_ = new RegExp("/[^a-zA-Z0-9]/");
      const char1 = one.charAt(one.length - 1);
      const char2 = two.charAt(0);
      const nonAlphaNumeric1 = char1.match(nonAlphaNumericRegex_);
      const nonAlphaNumeric2 = char2.match(nonAlphaNumericRegex_);
      const whitespace1 = nonAlphaNumeric1 && char1.match(this.whitespaceRegex_);
      const whitespace2 = nonAlphaNumeric2 && char2.match(this.whitespaceRegex_);
      const lineBreak1 = whitespace1 && char1.match(this.linebreakRegex_);
      const lineBreak2 = whitespace2 && char2.match(this.linebreakRegex_);
      const blankLine1 = lineBreak1 && one.match(this.blanklineEndRegex_);
      const blankLine2 = lineBreak2 && two.match(this.blanklineStartRegex_);
      if (blankLine1 || blankLine2) {
        return 5;
      } else if (lineBreak1 || lineBreak2) {
        return 4;
      } else if (nonAlphaNumeric1 && !whitespace1 && whitespace2) {
        return 3;
      } else if (whitespace1 || whitespace2) {
        return 2;
      } else if (nonAlphaNumeric1 || nonAlphaNumeric2) {
        return 1;
      }
      return 0;
    };
    let pointer = 1;
    while (pointer < diffs.length - 1) {
      if (diffs[pointer - 1][0] === 0 /* Equal */ && diffs[pointer + 1][0] === 0 /* Equal */) {
        let equality1 = diffs[pointer - 1][1];
        let edit = diffs[pointer][1];
        let equality2 = diffs[pointer + 1][1];
        const commonOffset = this.diff_commonSuffix(equality1, edit);
        if (commonOffset) {
          const commonString = edit.substring(edit.length - commonOffset);
          equality1 = equality1.substring(0, equality1.length - commonOffset);
          edit = commonString + edit.substring(0, edit.length - commonOffset);
          equality2 = commonString + equality2;
        }
        let bestEquality1 = equality1;
        let bestEdit = edit;
        let bestEquality2 = equality2;
        let bestScore = diff_cleanupSemanticScore_(equality1, edit) + diff_cleanupSemanticScore_(edit, equality2);
        while (edit.charAt(0) === equality2.charAt(0)) {
          equality1 += edit.charAt(0);
          edit = edit.substring(1) + equality2.charAt(0);
          equality2 = equality2.substring(1);
          const score = diff_cleanupSemanticScore_(equality1, edit) + diff_cleanupSemanticScore_(edit, equality2);
          if (score >= bestScore) {
            bestScore = score;
            bestEquality1 = equality1;
            bestEdit = edit;
            bestEquality2 = equality2;
          }
        }
        if (diffs[pointer - 1][1] !== bestEquality1) {
          if (bestEquality1) {
            diffs[pointer - 1][1] = bestEquality1;
          } else {
            diffs.splice(pointer - 1, 1);
            pointer--;
          }
          diffs[pointer][1] = bestEdit;
          if (bestEquality2) {
            diffs[pointer + 1][1] = bestEquality2;
          } else {
            diffs.splice(pointer + 1, 1);
            pointer--;
          }
        }
      }
      pointer++;
    }
  }
  /**
   * loc is a location in text1, compute and return the equivalent location in
   * text2.
   * e.g. 'The cat' vs 'The big cat', 1->1, 5->8
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @param {number} loc Location within text1.
   * @return {number} Location within text2.
   */
  diff_xIndex(diffs, loc) {
    let chars1 = 0;
    let chars2 = 0;
    let last_chars1 = 0;
    let last_chars2 = 0;
    let x;
    for (x = 0; x < diffs.length; x++) {
      if (diffs[x][0] !== 1 /* Insert */) {
        chars1 += diffs[x][1].length;
      }
      if (diffs[x][0] !== -1 /* Delete */) {
        chars2 += diffs[x][1].length;
      }
      if (chars1 > loc) {
        break;
      }
      last_chars1 = chars1;
      last_chars2 = chars2;
    }
    if (diffs.length !== x && diffs[x][0] === -1 /* Delete */) {
      return last_chars2;
    }
    return last_chars2 + (loc - last_chars1);
  }
  /**
   * Crush the diff into an encoded string which describes the operations
   * required to transform text1 into text2.
   * E.g. =3\t-2\t+ing  -> Keep 3 chars, delete 2 chars, insert 'ing'.
   * Operations are tab-separated.  Inserted text is escaped using %xx notation.
   * @param {!Array.<!diff_match_patch.Diff>} diffs Array of diff tuples.
   * @return {string} Delta text.
   */
  diff_toDelta(diffs) {
    const text = [];
    for (let x = 0; x < diffs.length; x++) {
      switch (diffs[x][0]) {
        case 1 /* Insert */:
          text[x] = "+" + encodeURI(diffs[x][1]);
          break;
        case -1 /* Delete */:
          text[x] = "-" + diffs[x][1].length;
          break;
        case 0 /* Equal */:
          text[x] = "=" + diffs[x][1].length;
          break;
      }
    }
    return text.join("	").replace(/%20/g, " ");
  }
  /**
   * Given the original text1, and an encoded string which describes the
   * operations required to transform text1 into text2, compute the full diff.
   * @param {string} text1 Source string for the diff.
   * @param {string} delta Delta text.
   * @return {!Array.<!diff_match_patch.Diff>} Array of diff tuples.
   * @throws {!Error} If invalid input.
   */
  diff_fromDelta(text1, delta) {
    const diffs = [];
    let diffsLength = 0;
    let pointer = 0;
    const tokens = delta.split(/\t/g);
    for (const token of tokens) {
      const param = token.substring(1);
      switch (token.charAt(0)) {
        case "+":
          try {
            diffs[diffsLength++] = [1 /* Insert */, decodeURI(param)];
          } catch (ex) {
            throw new Error("Illegal escape in diff_fromDelta: " + param);
          }
          break;
        case "-":
        case "=":
          const n = parseInt(param, 10);
          if (isNaN(n) || n < 0) {
            throw new Error("Invalid number in diff_fromDelta: " + param);
          }
          const text = text1.substring(pointer, pointer += n);
          if (token.charAt(0) === "=") {
            diffs[diffsLength++] = [0 /* Equal */, text];
          } else {
            diffs[diffsLength++] = [-1 /* Delete */, text];
          }
          break;
        default:
          if (token) {
            throw new Error(`Invalid diff operation in diff_fromDelta: ${token}`);
          }
      }
    }
    if (pointer !== text1.length) {
      throw new Error("Delta length (" + pointer + ") does not equal source text length (" + text1.length + ").");
    }
    return diffs;
  }
  /**
   * Locate the best instance of 'pattern' in 'text' near 'loc'.
   * @param {string} text The text to search.
   * @param {string} pattern The pattern to search for.
   * @param {number} loc The location to search around.
   * @return {number} Best match index or -1.
   */
  match_main(text, pattern, loc) {
    if (text == null || pattern == null || loc == null) {
      throw new Error("Null input. (match_main)");
    }
    loc = Math.max(0, Math.min(loc, text.length));
    if (text === pattern) {
      return 0;
    } else if (!text.length) {
      return -1;
    } else if (text.substring(loc, loc + pattern.length) === pattern) {
      return loc;
    } else {
      return this.match_bitap_(text, pattern, loc);
    }
  }
  /**
   * Locate the best instance of 'pattern' in 'text' near 'loc' using the
   * Bitap algorithm.
   * @param {string} text The text to search.
   * @param {string} pattern The pattern to search for.
   * @param {number} loc The location to search around.
   * @return {number} Best match index or -1.
   * @private
   */
  match_bitap_(text, pattern, loc) {
    if (pattern.length > this.Match_MaxBits) {
      throw new Error("Pattern too long for this browser.");
    }
    const s = this.match_alphabet_(pattern);
    const dmp2 = this;
    function match_bitapScore_(e, x) {
      const accuracy = e / pattern.length;
      const proximity = Math.abs(loc - x);
      if (!dmp2.Match_Distance) {
        return proximity ? 1 : accuracy;
      }
      return accuracy + proximity / dmp2.Match_Distance;
    }
    let score_threshold = this.Match_Threshold;
    let best_loc = text.indexOf(pattern, loc);
    if (best_loc !== -1) {
      score_threshold = Math.min(match_bitapScore_(0, best_loc), score_threshold);
      best_loc = text.lastIndexOf(pattern, loc + pattern.length);
      if (best_loc !== -1) {
        score_threshold = Math.min(match_bitapScore_(0, best_loc), score_threshold);
      }
    }
    const matchmask = 1 << pattern.length - 1;
    best_loc = -1;
    let bin_min;
    let bin_mid;
    let bin_max = pattern.length + text.length;
    let last_rd;
    for (let d = 0; d < pattern.length; d++) {
      bin_min = 0;
      bin_mid = bin_max;
      while (bin_min < bin_mid) {
        if (match_bitapScore_(d, loc + bin_mid) <= score_threshold) {
          bin_min = bin_mid;
        } else {
          bin_max = bin_mid;
        }
        bin_mid = Math.floor((bin_max - bin_min) / 2 + bin_min);
      }
      bin_max = bin_mid;
      let start = Math.max(1, loc - bin_mid + 1);
      const finish = Math.min(loc + bin_mid, text.length) + pattern.length;
      const rd = Array(finish + 2);
      rd[finish + 1] = (1 << d) - 1;
      for (let j = finish; j >= start; j--) {
        const charMatch = s[text.charAt(j - 1)];
        if (d === 0) {
          rd[j] = (rd[j + 1] << 1 | 1) & charMatch;
        } else {
          rd[j] = (rd[j + 1] << 1 | 1) & charMatch | ((last_rd[j + 1] | last_rd[j]) << 1 | 1) | last_rd[j + 1];
        }
        if (rd[j] & matchmask) {
          const score = match_bitapScore_(d, j - 1);
          if (score <= score_threshold) {
            score_threshold = score;
            best_loc = j - 1;
            if (best_loc > loc) {
              start = Math.max(1, 2 * loc - best_loc);
            } else {
              break;
            }
          }
        }
      }
      if (match_bitapScore_(d + 1, loc) > score_threshold) {
        break;
      }
      last_rd = rd;
    }
    return best_loc;
  }
  /**
   * Initialise the alphabet for the Bitap algorithm.
   * @param {string} pattern The text to encode.
   * @return {!Object} Hash of character locations.
   * @private
   */
  match_alphabet_(pattern) {
    const s = {};
    for (let i = 0; i < pattern.length; i++) {
      s[pattern.charAt(i)] = 0;
    }
    for (let i = 0; i < pattern.length; i++) {
      s[pattern.charAt(i)] |= 1 << pattern.length - i - 1;
    }
    return s;
  }
  /**
   * Increase the context until it is unique,
   * but don't let the pattern expand beyond Match_MaxBits.
   * @param {!diff_match_patch.PatchOperation} patch The patch to grow.
   * @param {string} text Source text.
   * @private
   */
  patch_addContext_(patch, text) {
    if (text.length === 0) {
      return;
    }
    let pattern = text.substring(patch.start2, patch.start2 + patch.length1);
    let padding = 0;
    while (text.indexOf(pattern) !== text.lastIndexOf(pattern) && pattern.length < this.Match_MaxBits - this.Patch_Margin - this.Patch_Margin) {
      padding += this.Patch_Margin;
      pattern = text.substring(
        patch.start2 - padding,
        patch.start2 + patch.length1 + padding
      );
    }
    padding += this.Patch_Margin;
    const prefix = text.substring(patch.start2 - padding, patch.start2);
    if (prefix) {
      patch.diffs.unshift([0 /* Equal */, prefix]);
    }
    const suffix = text.substring(
      patch.start2 + patch.length1,
      patch.start2 + patch.length1 + padding
    );
    if (suffix) {
      patch.diffs.push([0 /* Equal */, suffix]);
    }
    patch.start1 -= prefix.length;
    patch.start2 -= prefix.length;
    patch.length1 += prefix.length + suffix.length;
    patch.length2 += prefix.length + suffix.length;
  }
  /**
   * Given an array of patches, return another array that is identical.
   * @param {!Array.<!diff_match_patch.PatchOperation>} patches Array of Patch objects.
   * @return {!Array.<!diff_match_patch.PatchOperation>} Array of Patch objects.
   */
  patch_deepCopy(patches) {
    const patchesCopy = [];
    for (let x = 0; x < patches.length; x++) {
      const patch = patches[x];
      const patchCopy = new PatchOperation();
      patchCopy.diffs = [];
      for (let y = 0; y < patch.diffs.length; y++) {
        patchCopy.diffs[y] = [patch.diffs[y][0], patch.diffs[y][1]];
      }
      patchCopy.start1 = patch.start1;
      patchCopy.start2 = patch.start2;
      patchCopy.length1 = patch.length1;
      patchCopy.length2 = patch.length2;
      patchesCopy[x] = patchCopy;
    }
    return patchesCopy;
  }
  /**
   * Add some padding on text start and end so that edges can match something.
   * Intended to be called only from within patch_apply.
   * @param {!Array.<!diff_match_patch.PatchOperation>} patches Array of Patch objects.
   * @return {string} The padding string added to each side.
   */
  patch_addPadding(patches) {
    const paddingLength = this.Patch_Margin;
    let nullPadding = "";
    for (let x = 1; x <= paddingLength; x++) {
      nullPadding += String.fromCharCode(x);
    }
    for (const patchElement of patches) {
      patchElement.start1 += paddingLength;
      patchElement.start2 += paddingLength;
    }
    let patch = patches[0];
    let diffs = patch.diffs;
    if (diffs.length === 0 || diffs[0][0] !== 0 /* Equal */) {
      diffs.unshift([0 /* Equal */, nullPadding]);
      patch.start1 -= paddingLength;
      patch.start2 -= paddingLength;
      patch.length1 += paddingLength;
      patch.length2 += paddingLength;
    } else if (paddingLength > diffs[0][1].length) {
      const extraLength = paddingLength - diffs[0][1].length;
      diffs[0][1] = nullPadding.substring(diffs[0][1].length) + diffs[0][1];
      patch.start1 -= extraLength;
      patch.start2 -= extraLength;
      patch.length1 += extraLength;
      patch.length2 += extraLength;
    }
    patch = patches[patches.length - 1];
    diffs = patch.diffs;
    if (diffs.length === 0 || diffs[diffs.length - 1][0] !== 0 /* Equal */) {
      diffs.push([0 /* Equal */, nullPadding]);
      patch.length1 += paddingLength;
      patch.length2 += paddingLength;
    } else if (paddingLength > diffs[diffs.length - 1][1].length) {
      const extraLength = paddingLength - diffs[diffs.length - 1][1].length;
      diffs[diffs.length - 1][1] += nullPadding.substring(0, extraLength);
      patch.length1 += extraLength;
      patch.length2 += extraLength;
    }
    return nullPadding;
  }
  /**
   * Look through the patches and break up any which are longer than the maximum
   * limit of the match algorithm.
   * Intended to be called only from within patch_apply.
   * @param {!Array.<!diff_match_patch.PatchOperation>} patches Array of Patch objects.
   */
  patch_splitMax(patches) {
    const patch_size = this.Match_MaxBits;
    for (let x = 0; x < patches.length; x++) {
      if (patches[x].length1 <= patch_size) {
        continue;
      }
      const bigpatch = patches[x];
      patches.splice(x--, 1);
      let start1 = bigpatch.start1;
      let start2 = bigpatch.start2;
      let precontext = "";
      while (bigpatch.diffs.length !== 0) {
        const patch = new PatchOperation();
        let empty = true;
        patch.start1 = start1 - precontext.length;
        patch.start2 = start2 - precontext.length;
        if (precontext !== "") {
          patch.length1 = patch.length2 = precontext.length;
          patch.diffs.push([0 /* Equal */, precontext]);
        }
        while (bigpatch.diffs.length !== 0 && patch.length1 < patch_size - this.Patch_Margin) {
          const diff_type = bigpatch.diffs[0][0];
          let diff_text = bigpatch.diffs[0][1];
          if (diff_type === 1 /* Insert */) {
            patch.length2 += diff_text.length;
            start2 += diff_text.length;
            patch.diffs.push(bigpatch.diffs.shift());
            empty = false;
          } else if (diff_type === -1 /* Delete */ && patch.diffs.length === 1 && patch.diffs[0][0] === 0 /* Equal */ && diff_text.length > 2 * patch_size) {
            patch.length1 += diff_text.length;
            start1 += diff_text.length;
            empty = false;
            patch.diffs.push([diff_type, diff_text]);
            bigpatch.diffs.shift();
          } else {
            diff_text = diff_text.substring(
              0,
              patch_size - patch.length1 - this.Patch_Margin
            );
            patch.length1 += diff_text.length;
            start1 += diff_text.length;
            if (diff_type === 0 /* Equal */) {
              patch.length2 += diff_text.length;
              start2 += diff_text.length;
            } else {
              empty = false;
            }
            patch.diffs.push([diff_type, diff_text]);
            if (diff_text === bigpatch.diffs[0][1]) {
              bigpatch.diffs.shift();
            } else {
              bigpatch.diffs[0][1] = bigpatch.diffs[0][1].substring(diff_text.length);
            }
          }
        }
        precontext = this.diff_text2(patch.diffs);
        precontext = precontext.substring(precontext.length - this.Patch_Margin);
        const postcontext = this.diff_text1(bigpatch.diffs).substring(0, this.Patch_Margin);
        if (postcontext !== "") {
          patch.length1 += postcontext.length;
          patch.length2 += postcontext.length;
          if (patch.diffs.length !== 0 && patch.diffs[patch.diffs.length - 1][0] === 0 /* Equal */) {
            patch.diffs[patch.diffs.length - 1][1] += postcontext;
          } else {
            patch.diffs.push([0 /* Equal */, postcontext]);
          }
        }
        if (!empty) {
          patches.splice(++x, 0, patch);
        }
      }
    }
  }
};

// src/internal/utils/dmp.ts
var dmp = new DiffMatchPatch();
dmp.Diff_Timeout = 0.2;

// src/internal/utils/get-properties.ts
function getProperties(goal, before) {
  const props = {};
  for (const x in goal) {
    if (x !== "text") {
      if (before == null) {
        if (goal[x]) {
          props[x] = goal[x];
        }
      } else {
        if (goal[x] !== before[x]) {
          if (goal[x]) {
            props[x] = goal[x];
          } else {
            props[x] = void 0;
          }
        }
      }
    }
  }
  if (before != null) {
    for (const x in before) {
      if (x !== "text" && goal[x] == null) {
        props[x] = void 0;
      }
    }
  }
  return props;
}

// src/internal/utils/inline-node-char-map.ts
var import_server = require("@udecode/plate-common/server");
var InlineNodeCharMap = class {
  constructor({ charGenerator }) {
    this._charToNode = /* @__PURE__ */ new Map();
    this._charGenerator = charGenerator;
  }
  insertBetweenPairs(arr, between) {
    return arr.flatMap((x, i) => {
      if (i === arr.length - 1)
        return x;
      return [x, between];
    });
  }
  replaceCharWithNode(haystack, needle, replacementNode) {
    return haystack.flatMap((haystackNode) => {
      if (!(0, import_server.isText)(haystackNode))
        return [haystackNode];
      const splitText = haystackNode.text.split(needle);
      if (splitText.length === 1)
        return [haystackNode];
      const replacementWithProps = __spreadValues(__spreadValues({}, replacementNode), (0, import_server.getNodeProps)(haystackNode));
      const nodesForTexts = splitText.map((text) => __spreadProps(__spreadValues({}, haystackNode), {
        text
      }));
      const nodeList = this.insertBetweenPairs(
        nodesForTexts,
        replacementWithProps
      );
      return nodeList.filter((n) => !(0, import_server.isText)(n) || n.text.length > 0);
    });
  }
  // Replace non-text nodes with a text node containing a unique char
  nodeToText(node) {
    if ((0, import_server.isText)(node))
      return node;
    const c = this._charGenerator.next().value;
    this._charToNode.set(c, node);
    return { text: c };
  }
  // Replace chars in text node with original nodes
  textToNode(initialTextNode) {
    let outputNodes = [initialTextNode];
    for (const [c, originalNode] of this._charToNode) {
      outputNodes = this.replaceCharWithNode(outputNodes, c, originalNode);
    }
    return outputNodes;
  }
};

// src/internal/utils/unused-char-generator.ts
function* unusedCharGenerator({
  skipChars = ""
} = {}) {
  const skipSet = new Set(skipChars);
  for (let code = "A".codePointAt(0); ; code++) {
    const c = String.fromCodePoint(code);
    if (skipSet.has(c))
      continue;
    yield c;
  }
}

// src/internal/utils/with-change-tracking.ts
var import_server2 = require("@udecode/plate-common/server");
var import_isEqual2 = __toESM(require("lodash/isEqual.js"));
var import_uniqWith = __toESM(require("lodash/uniqWith.js"));
var import_slate = require("slate");
var withChangeTracking = (editor, options) => {
  const e = editor;
  e.propsChanges = [];
  e.insertedTexts = [];
  e.removedTexts = [];
  e.recordingOperations = true;
  const { apply } = e;
  e.apply = (op) => applyWithChangeTracking(e, apply, op);
  e.commitChangesToDiffs = () => commitChangesToDiffs(e, options);
  return e;
};
var applyWithChangeTracking = (editor, apply, op) => {
  if (!editor.recordingOperations) {
    return apply(op);
  }
  withoutRecordingOperations(editor, () => {
    switch (op.type) {
      case "insert_text": {
        applyInsertText(editor, apply, op);
        break;
      }
      case "remove_text": {
        applyRemoveText(editor, apply, op);
        break;
      }
      case "merge_node": {
        applyMergeNode(editor, apply, op);
        break;
      }
      case "split_node": {
        applySplitNode(editor, apply, op);
        break;
      }
      case "set_node": {
        applySetNode(editor, apply, op);
        break;
      }
      default: {
        apply(op);
      }
    }
  });
};
var applyInsertText = (editor, apply, op) => {
  const node = import_slate.Node.get(editor, op.path);
  apply(op);
  const startPoint = { offset: op.offset, path: op.path };
  const endPoint = { offset: op.offset + op.text.length, path: op.path };
  const range = { anchor: startPoint, focus: endPoint };
  const rangeRef = import_slate.Editor.rangeRef(editor, range);
  editor.insertedTexts.push({
    node: __spreadProps(__spreadValues({}, node), {
      text: op.text
    }),
    rangeRef
  });
};
var applyRemoveText = (editor, apply, op) => {
  const node = import_slate.Node.get(editor, op.path);
  apply(op);
  const point = { offset: op.offset, path: op.path };
  const pointRef = import_slate.Editor.pointRef(editor, point, {
    affinity: "backward"
  });
  editor.removedTexts.push({
    node: __spreadProps(__spreadValues({}, node), {
      text: op.text
    }),
    pointRef
  });
};
var applyMergeNode = (editor, apply, op) => {
  const oldNode = import_slate.Node.get(editor, op.path);
  const properties = import_slate.Node.extractProps(oldNode);
  const prevNodePath = import_slate.Path.previous(op.path);
  const prevNode = import_slate.Node.get(editor, prevNodePath);
  const newProperties = import_slate.Node.extractProps(prevNode);
  apply(op);
  const startPoint = { offset: prevNode.text.length, path: prevNodePath };
  const endPoint = import_slate.Editor.end(editor, prevNodePath);
  const range = { anchor: startPoint, focus: endPoint };
  const rangeRef = import_slate.Editor.rangeRef(editor, range);
  editor.propsChanges.push({
    newProperties,
    properties,
    rangeRef
  });
};
var applySplitNode = (editor, apply, op) => {
  const oldNode = import_slate.Node.get(editor, op.path);
  const properties = import_slate.Node.extractProps(oldNode);
  const newProperties = op.properties;
  apply(op);
  const newNodePath = import_slate.Path.next(op.path);
  const newNodeRange = import_slate.Editor.range(editor, newNodePath);
  const rangeRef = import_slate.Editor.rangeRef(editor, newNodeRange);
  editor.propsChanges.push({
    newProperties,
    properties,
    rangeRef
  });
};
var applySetNode = (editor, apply, op) => {
  apply(op);
  const range = import_slate.Editor.range(editor, op.path);
  const rangeRef = import_slate.Editor.rangeRef(editor, range);
  editor.propsChanges.push({
    newProperties: op.newProperties,
    properties: op.properties,
    rangeRef
  });
};
var commitChangesToDiffs = (editor, { getDeleteProps, getInsertProps, getUpdateProps }) => {
  withoutRecordingOperations(editor, () => {
    const flatUpdates = flattenPropsChanges(editor).reverse();
    flatUpdates.forEach(({ newProperties, properties, range }) => {
      const node = import_slate.Node.get(editor, range.anchor.path);
      (0, import_server2.addRangeMarks)(
        editor,
        getUpdateProps(node, properties, newProperties),
        { at: range }
      );
    });
    editor.removedTexts.forEach(({ node, pointRef }) => {
      const point = pointRef.current;
      if (point) {
        editor.insertNode(
          __spreadValues(__spreadValues({}, node), getDeleteProps(node)),
          { at: point }
        );
      }
      pointRef.unref();
    });
    editor.insertedTexts.forEach(({ node, rangeRef }) => {
      const range = rangeRef.current;
      if (range) {
        (0, import_server2.addRangeMarks)(editor, getInsertProps(node), { at: range });
      }
      rangeRef.unref();
    });
  });
};
var flattenPropsChanges = (editor) => {
  const propChangeRangeRefs = editor.propsChanges.map(
    ({ rangeRef }) => rangeRef
  );
  const insertedTextRangeRefs = editor.insertedTexts.map(
    ({ rangeRef }) => rangeRef
  );
  const unsortedRangePoints = [
    ...propChangeRangeRefs,
    ...insertedTextRangeRefs
  ].flatMap((rangeRef) => {
    const range = rangeRef.current;
    if (!range)
      return [];
    return [range.anchor, range.focus];
  });
  const rangePoints = (0, import_uniqWith.default)(
    unsortedRangePoints.sort(import_slate.Point.compare),
    import_slate.Point.equals
  );
  if (rangePoints.length < 2)
    return [];
  const flatRanges = Array.from({ length: rangePoints.length - 1 }).fill(null).map((_, i) => ({
    anchor: rangePoints[i],
    focus: rangePoints[i + 1]
  }));
  const flatUpdates = flatRanges.map((flatRange) => {
    const getIntersectingChanges = (changes) => changes.filter(({ rangeRef }) => {
      const range = rangeRef.current;
      if (!range)
        return false;
      const intersection = import_slate.Range.intersection(range, flatRange);
      if (!intersection)
        return false;
      return import_slate.Range.isExpanded(intersection);
    });
    if (getIntersectingChanges(editor.insertedTexts).length > 0)
      return null;
    const intersectingUpdates = getIntersectingChanges(editor.propsChanges);
    if (intersectingUpdates.length === 0)
      return null;
    const initialProps = objectWithoutUndefined(
      intersectingUpdates[0].properties
    );
    const finalProps = objectWithoutUndefined(
      intersectingUpdates.at(-1).newProperties
    );
    if ((0, import_isEqual2.default)(initialProps, finalProps))
      return null;
    const properties = {};
    const newProperties = {};
    for (const key of Object.keys(finalProps)) {
      if (!(0, import_isEqual2.default)(initialProps[key], finalProps[key])) {
        properties[key] = initialProps[key];
        newProperties[key] = finalProps[key];
      }
    }
    for (const key of Object.keys(initialProps)) {
      if (finalProps[key] === void 0) {
        properties[key] = initialProps[key];
        newProperties[key] = void 0;
      }
    }
    return {
      newProperties,
      properties,
      range: flatRange
    };
  });
  propChangeRangeRefs.forEach((rangeRef) => rangeRef.unref());
  return flatUpdates.filter(Boolean);
};
var objectWithoutUndefined = (obj) => {
  const newObj = {};
  Object.keys(obj).forEach((key) => {
    if (obj[key] !== void 0) {
      newObj[key] = obj[key];
    }
  });
  return newObj;
};
var withoutRecordingOperations = (editor, fn) => {
  editor.recordingOperations = false;
  fn();
  editor.recordingOperations = true;
};

// src/internal/transforms/transformDiffTexts.ts
function transformDiffTexts(nodes, nextNodes, options) {
  if (nodes.length === 0)
    throw new Error("must have at least one nodes");
  if (nextNodes.length === 0)
    throw new Error("must have at least one nextNodes");
  const { lineBreakChar } = options;
  const hasLineBreakChar = lineBreakChar !== void 0;
  const charGenerator = unusedCharGenerator({
    // Do not use any char that is present in the text
    skipChars: nodes.concat(nextNodes).filter(import_server3.isText).map((n) => n.text).join("")
  });
  const insertedLineBreakProxyChar = hasLineBreakChar ? charGenerator.next().value : void 0;
  const deletedLineBreakProxyChar = hasLineBreakChar ? charGenerator.next().value : void 0;
  const inlineNodeCharMap = new InlineNodeCharMap({
    charGenerator
  });
  const texts = nodes.map((n) => inlineNodeCharMap.nodeToText(n));
  const nextTexts = nextNodes.map((n) => inlineNodeCharMap.nodeToText(n));
  const nodesEditor = withChangeTracking((0, import_slate2.createEditor)(), options);
  nodesEditor.children = [{ children: texts }];
  (0, import_slate2.withoutNormalizing)(nodesEditor, () => {
    let node = texts[0];
    if (texts.length > 1) {
      for (let i = 1; i < texts.length; i++) {
        nodesEditor.apply({
          path: [0, 1],
          position: 0,
          // Required by type; not actually used here
          properties: {},
          // Required by type; not actually used here
          type: "merge_node"
        });
        node = __spreadProps(__spreadValues({}, node), { text: node.text + texts[i].text });
      }
    }
    for (const op of splitTextNodes(node, nextTexts, {
      deletedLineBreakChar: deletedLineBreakProxyChar,
      insertedLineBreakChar: insertedLineBreakProxyChar
    })) {
      nodesEditor.apply(op);
    }
    nodesEditor.commitChangesToDiffs();
  });
  let diffTexts = nodesEditor.children[0].children;
  if (hasLineBreakChar) {
    diffTexts = diffTexts.map((n) => __spreadProps(__spreadValues({}, n), {
      text: n.text.replaceAll(insertedLineBreakProxyChar, lineBreakChar + "\n").replaceAll(deletedLineBreakProxyChar, lineBreakChar)
    }));
  }
  return diffTexts.flatMap((t) => inlineNodeCharMap.textToNode(t));
}
function slateTextDiff(a, b, { deletedLineBreakChar, insertedLineBreakChar }) {
  const diff = dmp.diff_main(a, b);
  dmp.diff_cleanupSemantic(diff);
  const operations = [];
  let offset = 0;
  let i = 0;
  while (i < diff.length) {
    const chunk = diff[i];
    const op = chunk[0];
    const text = chunk[1];
    switch (op) {
      case 0: {
        offset += text.length;
        break;
      }
      case -1: {
        operations.push({
          offset,
          text: deletedLineBreakChar === void 0 ? text : text.replaceAll("\n", deletedLineBreakChar),
          type: "remove_text"
        });
        break;
      }
      case 1: {
        operations.push({
          offset,
          text: insertedLineBreakChar === void 0 ? text : text.replaceAll("\n", insertedLineBreakChar),
          type: "insert_text"
        });
        offset += text.length;
        break;
      }
    }
    i += 1;
  }
  return operations;
}
function splitTextNodes(node, split, options) {
  if (split.length === 0) {
    return [
      {
        node,
        path: [0, 0],
        type: "remove_node"
      }
    ];
  }
  let splitText = "";
  for (const { text } of split) {
    splitText += text;
  }
  const nodeText = node.text;
  const operations = [];
  if (splitText !== nodeText) {
    for (const op of slateTextDiff(nodeText, splitText, options)) {
      operations.push(__spreadValues({ path: [0, 0] }, op));
    }
  }
  const newProperties = getProperties(split[0], node);
  if (getKeysLength(newProperties) > 0) {
    operations.push({
      newProperties,
      path: [0, 0],
      properties: getProperties(node),
      type: "set_node"
    });
  }
  let properties = getProperties(split[0]);
  let splitPath = [0, 0];
  for (let i = 0; i < split.length - 1; i++) {
    const part = split[i];
    const nextPart = split[i + 1];
    const newProps = getProperties(nextPart);
    Object.keys(properties).forEach((key) => {
      if (!newProps.hasOwnProperty(key)) {
        newProps[key] = void 0;
      }
    });
    operations.push({
      path: splitPath,
      position: part.text.length,
      properties: newProps,
      type: "split_node"
    });
    splitPath = import_slate2.Path.next(splitPath);
    properties = getProperties(nextPart);
  }
  return operations;
}
function getKeysLength(obj) {
  if (obj == null) {
    return 0;
  }
  return Object.keys(obj).length;
}

// src/internal/utils/diff-nodes.ts
var import_server4 = require("@udecode/plate-common/server");
var import_isEqual3 = __toESM(require("lodash/isEqual.js"));
function diffNodes(originNodes, targetNodes, { elementsAreRelated }) {
  const result = [];
  let relatedNode;
  const leftTargetNodes = [...targetNodes];
  originNodes.forEach((originNode) => {
    let childrenUpdated = false;
    let nodeUpdated = false;
    relatedNode = leftTargetNodes.find((targetNode) => {
      var _a;
      if ((0, import_server4.isElement)(originNode) && (0, import_server4.isElement)(targetNode)) {
        const relatedResult = (_a = elementsAreRelated == null ? void 0 : elementsAreRelated(originNode, targetNode)) != null ? _a : null;
        if (relatedResult !== null)
          return relatedResult;
      }
      if (isEqualNode(originNode, targetNode)) {
        childrenUpdated = true;
      }
      if (isEqualNodeChildren(originNode, targetNode)) {
        nodeUpdated = true;
      }
      return nodeUpdated || childrenUpdated;
    });
    if (relatedNode) {
      const insertNodes = leftTargetNodes.splice(
        0,
        leftTargetNodes.indexOf(relatedNode)
      );
      insertNodes.forEach((insertNode) => {
        result.push({
          insert: true,
          originNode: insertNode
        });
      });
      leftTargetNodes.splice(0, 1);
    }
    result.push({
      childrenUpdated,
      delete: !relatedNode,
      nodeUpdated,
      originNode,
      relatedNode
    });
  });
  leftTargetNodes.forEach((insertNode) => {
    result.push({
      insert: true,
      originNode: insertNode
    });
  });
  return result;
}
function isEqualNode(value, other) {
  return (0, import_server4.isElement)(value) && (0, import_server4.isElement)(other) && value.children !== null && other.children !== null && (0, import_isEqual3.default)(copyWithout(value, ["children"]), copyWithout(other, ["children"]));
}
function isEqualNodeChildren(value, other) {
  if ((0, import_server4.isElement)(value) && (0, import_server4.isElement)(other) && (0, import_isEqual3.default)(value.children, other.children)) {
    return true;
  }
  return (0, import_server4.isText)(value) && (0, import_server4.isText)(other) && (0, import_isEqual3.default)(value.text, other.text);
}

// src/internal/transforms/transformDiffDescendants.ts
function transformDiffDescendants(diff, _a) {
  var _b = _a, { stringCharMapping } = _b, options = __objRest(_b, ["stringCharMapping"]);
  const { getDeleteProps, getInsertProps, ignoreProps, isInline } = options;
  let i = 0;
  const children = [];
  let insertBuffer = [];
  let deleteBuffer = [];
  const flushBuffers = () => {
    children.push(...deleteBuffer, ...insertBuffer);
    insertBuffer = [];
    deleteBuffer = [];
  };
  const insertNode = (node) => insertBuffer.push(__spreadValues(__spreadValues({}, node), getInsertProps(node)));
  const deleteNode = (node) => deleteBuffer.push(__spreadValues(__spreadValues({}, node), getDeleteProps(node)));
  const passThroughNodes = (...nodes) => {
    flushBuffers();
    children.push(...nodes);
  };
  const areNodeListsEquivalent = (nodes0, nodes1) => {
    const excludeIgnoreProps = (node) => copyWithout(node, ignoreProps || []);
    const nodesWithoutIgnore0 = nodes0.map(excludeIgnoreProps);
    const nodesWithoutIgnore1 = nodes1.map(excludeIgnoreProps);
    return (0, import_isEqual4.default)(nodesWithoutIgnore0, nodesWithoutIgnore1);
  };
  const isInlineList = (nodes) => nodes.every((node) => (0, import_server5.isText)(node) || isInline(node));
  while (i < diff.length) {
    const chunk = diff[i];
    const op = chunk[0];
    const val = chunk[1];
    const nodes = stringCharMapping.stringToNodes(val);
    if (op === 0) {
      passThroughNodes(...nodes);
      i += 1;
      continue;
    }
    if (op === -1) {
      if (i < diff.length - 1 && diff[i + 1][0] === 1) {
        const nextVal = diff[i + 1][1];
        const nextNodes = stringCharMapping.stringToNodes(nextVal);
        if (areNodeListsEquivalent(nodes, nextNodes)) {
          passThroughNodes(...nextNodes);
          i += 2;
          continue;
        }
        if (isInlineList(nodes) && isInlineList(nextNodes)) {
          passThroughNodes(...transformDiffTexts(nodes, nextNodes, options));
          i += 2;
          continue;
        }
        const diffResult = diffNodes(nodes, nextNodes, options);
        diffResult.forEach((item) => {
          if (item.delete) {
            deleteNode(item.originNode);
          }
          if (item.insert) {
            insertNode(item.originNode);
          }
          if (item.relatedNode) {
            const diffNodesResult = transformDiffNodes(
              item.originNode,
              item.relatedNode,
              options
            );
            if (diffNodesResult) {
              passThroughNodes(...diffNodesResult);
            } else {
              deleteNode(item.originNode);
              insertNode(item.relatedNode);
            }
          }
        });
        i += 2;
        continue;
      } else {
        for (const node of nodes) {
          deleteNode(node);
        }
        i += 1;
        continue;
      }
    }
    if (op === 1) {
      for (const node of nodes) {
        insertNode(node);
      }
      i += 1;
      continue;
    }
    throw new Error(
      "transformDiffDescendants: Missing continue statement or unhandled operation"
    );
  }
  flushBuffers();
  return children;
}

// src/internal/utils/string-char-mapping.ts
var import_isEqual5 = __toESM(require("lodash/isEqual.js"));
var StringCharMapping = class {
  constructor() {
    this._charGenerator = unusedCharGenerator();
    this._mappedNodes = [];
  }
  charToNode(c) {
    const entry = this._mappedNodes.find(([_node, c2]) => c2 === c);
    if (!entry)
      throw new Error(`No node found for char ${c}`);
    return entry[0];
  }
  nodeToChar(node) {
    for (const [n, c2] of this._mappedNodes) {
      if ((0, import_isEqual5.default)(n, node)) {
        return c2;
      }
    }
    const c = this._charGenerator.next().value;
    this._mappedNodes.push([node, c]);
    return c;
  }
  nodesToString(nodes) {
    return nodes.map(this.nodeToChar.bind(this)).join("");
  }
  stringToNodes(s) {
    return s.split("").map(this.charToNode.bind(this));
  }
};

// src/computeDiff.ts
var computeDiff = (doc0, doc1, _a = {}) => {
  var _b = _a, {
    getDeleteProps = defaultGetDeleteProps,
    getInsertProps = defaultGetInsertProps,
    getUpdateProps = defaultGetUpdateProps,
    ignoreProps,
    isInline = () => false
  } = _b, options = __objRest(_b, [
    "getDeleteProps",
    "getInsertProps",
    "getUpdateProps",
    "ignoreProps",
    "isInline"
  ]);
  const stringCharMapping = new StringCharMapping();
  const m0 = stringCharMapping.nodesToString(doc0);
  const m1 = stringCharMapping.nodesToString(doc1);
  const diff = dmp.diff_main(m0, m1);
  return transformDiffDescendants(diff, __spreadValues({
    getDeleteProps,
    getInsertProps,
    getUpdateProps: (node, properties, newProperties) => {
      if (ignoreProps && Object.keys(newProperties).every((key) => ignoreProps.includes(key)))
        return {};
      return getUpdateProps(node, properties, newProperties);
    },
    ignoreProps,
    isInline,
    stringCharMapping
  }, options));
};
var defaultGetInsertProps = () => ({
  diff: true,
  diffOperation: {
    type: "insert"
  }
});
var defaultGetDeleteProps = () => ({
  diff: true,
  diffOperation: {
    type: "delete"
  }
});
var defaultGetUpdateProps = (_node, properties, newProperties) => ({
  diff: true,
  diffOperation: {
    newProperties,
    properties,
    type: "update"
  }
});

// src/withGetFragmentExcludeDiff.ts
var import_cloneDeep = __toESM(require("lodash/cloneDeep.js"));
var withGetFragmentExcludeDiff = (editor) => {
  const { getFragment } = editor;
  editor.getFragment = () => {
    const fragment = (0, import_cloneDeep.default)(getFragment());
    const removeDiff = (node) => {
      if ("diff" in node)
        delete node.diff;
      if ("diffOperation" in node)
        delete node.diffOperation;
      if ("children" in node)
        node.children.forEach(removeDiff);
    };
    fragment.forEach(removeDiff);
    return fragment;
  };
  return editor;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  computeDiff,
  defaultGetDeleteProps,
  defaultGetInsertProps,
  defaultGetUpdateProps,
  withGetFragmentExcludeDiff
});
//# sourceMappingURL=index.js.map